import std.stdio;

import gameengine.core.engine;
import gameengine.math.types;
import gameengine.renderer.renderer;
import gameengine_rsdl;

import core.thread;

void main() {
	Renderer renderer = new RSDL("test", IntVec2(800, 600));
	Engine engine = new Engine(renderer);

	ubyte red = 0;
	bool increase = true;
	while (true) {
		engine.runNodeProcesses();

		// Colour changing background!
		if ((red == 255 && increase) || (red == 0 && !increase)) {
			increase = !increase;
		}
		if (increase) red += 1;
		else red -= 1;

		// Clear screen then sleep for ~16ms
		renderer.clearScreen(Color(red, 0, 0, 255));

		engine.drawNodes();
		renderer.renderCurrent();
		Thread.sleep(16.msecs);
	}
}
